// Copyright (c) 2005  INRIA Sophia-Antipolis (France).
// All rights reserved.
//
// This file is part of cgal-python; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with cgal-python.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Id: Py_Bbox_3.cpp 165 2007-11-02 14:35:12Z spion $
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal-python/trunk/cgal-python/bindings/Kernel/Py_Bbox_3.cpp $
//
// Author(s)     : Naceur Meskini
//=========================================================================

#include <CGAL/basic.h>
#include <CGAL/Bbox_3.h>

#include <boost/python.hpp>
#include <boost/cstdint.hpp>

template<class Bbox_3>
boost::python::str py_repr_Bbox_3(const Bbox_3& b )
{
	using namespace boost::python;
	return str("Bbox_3( xmin = " + str(b.xmin()) +",ymin = " + str(b.ymin()) +",zmin = " + str(b.zmin()) +",xmax = " + str(b.xmax()) + ",ymax = " + str(b.ymax())+ ",zmax = " + str(b.zmax()) +")" );
}

void export_Bbox_3()
{
	using namespace boost::python;

	typedef CGAL::Bbox_3 	Bbox_3;
   
	class_< Bbox_3 >("Bbox_3", init<  >())
        .def(init< const Bbox_3& >())
        .def(init< double, double, double, double, double, double >())
        .def("xmin", &Bbox_3::xmin)
        .def("ymin", &Bbox_3::ymin)
        .def("zmin", &Bbox_3::zmin)
        .def("xmax", &Bbox_3::xmax)
        .def("ymax", &Bbox_3::ymax)
        .def("zmax", &Bbox_3::zmax)
        .def("__repr__", &py_repr_Bbox_3<Bbox_3>)
        .def( self + self )
    ;
}
