// Copyright (c) 2005  INRIA Sophia-Antipolis (France).
// All rights reserved.
//
// This file is part of cgal-python; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with cgal-python.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Id: Py_Delaunay_mesher_2_doc.h 125 2006-06-06 16:27:38Z nmeskini $
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal-python/trunk/cgal-python/bindings/Mesh_2/Py_Delaunay_mesher_2_doc.h $
//
// Author(s)     : Naceur Meskini
//=========================================================================
#ifndef DELAUNAY_MESHER_2_DOCS_H
#define DELAUNAY_MESHER_2_DOCS_H
//=======================================================
// doc of Triangulation_3 class
//=======================================================
const char* Delaunay_mesher_2_doc = "\
	This class implements a 2D mesh generator.\n\
	for more details, see the C++ documentation:\n\
	http://www.cgal.org/Manual/3.2/doc_html/cgal_manual/Mesh_2_ref/Class_Delaunay_mesher_2.html";

const char* clear_seeds_doc = "\
	mesher.clear_seeds( self ) -> void\n\
	Sets seeds to the empty set. \n\
	All finite connected components of the constrained triangulation will be refined.";
const char* refine_mesh_doc = "\
	mesher.refine_mesh( self ) -> void\n\
	Refines the constrained Delaunay triangulation into a mesh satisfying \n\
	the criteria defined by the traits.";
const char* set_seeds_doc = "\
	mesher.set_seeds( self ,list seeds, bool mark = False) -> void\n\
	Sets seeds list. If mark=true, the mesh domain is the union of the \n\
	bounded connected components including at least one seed. \n\
	If mark=false, the domain is the union of the bounded components \n\
	including no seed. Note that the unbounded component of the plane is \n\
	never meshed.\n\
	Requirement: seeds are Point_2";

const char* set_criteria_doc = "\
	mesher.set_criteria( self ,aspect_bound = 0.125,size_bound = 0.0) -> void\n\
	Sets criteria of the mesh.";
const char* init_doc = "\
	mesher.init( self) -> void\n\
	This method must be called just before the first call to the following \n\
	step by step refinement method, that is when all vertices and constrained\n\
	edges have been inserted into the constrained Delaunay triangulation. \n\
	It must be called again before any subsequent calls to the step by step\n\
	refinement method if new vertices or constrained edges have been inserted\n\
	since the last call.";

const char* is_refinement_done_doc = "\
	mesher.is_refinement_done( self ) -> bool\n\
	Tests if the step by step refinement algorithm is done. \n\
	If it returns true, the following calls to step_by_step_refine_mesh will\n\
	not insert any points, until some new constrained segments or points are\n\
	inserted in the triangulation and init is called again.";

const char* step_by_step_refine_mesh_doc = "\
	mesher.step_by_step_refine_mesh( self ) -> bool\n\
	Applies one step of the algorithm, by inserting one point, \n\
	if the algorithm is not done. Returns false iff no point has been \n\
	inserted because the algorithm is done.";

const char* seeds_doc = "\
	Is python property which can be used to visit all seeds of the mesh.\
	by using the for statment:\n\
	for seed in mesher.seeds:\n\
		print seed.x(),seed.y()";


#endif  //DELAUNAY_MESHER_2_DOCS_H
