// Copyright (c) 2005  INRIA Sophia-Antipolis (France).
// All rights reserved.
//
// This file is part of cgal-python; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with cgal-python.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Id: Py_Constrained_triangulation_plus_2_doc.h 136 2006-07-12 16:29:58Z nmeskini $
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal-python/trunk/cgal-python/bindings/Triangulations_2/Py_Constrained_triangulation_plus_2_doc.h $
//
// Author(s)     : Naceur Meskini
//=========================================================================
//  doc of Constrained_triangulation_plus_2 class
//=================================================

const char* doc_Constrained_triangulation_plus_2 ="\
The class Constrained_triangulation_plus_2 implements a constrained triangulation\n\
with an additional data structure called the constraint hierarchy that keeps \n\
track of the input constraints and of their refinement in the triangulation.\n\
See a complete C++ documentation at:\n\
http://www.cgal.org/Manual/3.2/doc_html/cgal_manual/Triangulation_2_ref/Class_Constrained_triangulation_plus_2.html";

const char* doc_init = "\
ctp = Constrained_triangulation_plus_2()\nIntroduces an empty triangulation.";

const char* doc_clear ="\
"; 
const char* doc_copy ="\
";
const char* doc_swap ="\
"; 

const char* doc_insert_constraint ="\
ctp.insert_constraint ( Point_2 a, Point_2 b) -> void\n\
Inserts the constraint segment ab in the triangulation.\n\n\
ctp.insert_constraint ( Vertex va, Vertex vb) -> void\n\
Inserts a constraint whose endpoints are the vertices pointed by va and vb in the triangulation."; 

const char* doc_push_back ="\
ctp.push_back ( Point_2 p) -> Vertex\n\
Equivalent to insert(p).\n\n\
ctp.push_back ( Constraint c) -> void\n\
Inserts the constraint c.";

const char* doc_insert ="\
ctp.insert ( Point_2 p,Face start = Face()) -> Vertex\n\
Inserts point p as a vertex of the triangulation.\n\n\
ctp.insert ( list l) -> Inserts a list of points";

const char* doc_remove_constraint ="\
ctp.remove_constraint ( Vertex va,Vertex vb) -> void\n\
Removes the constraint joining the vertices pointed by va and vb.\n\
Precondition: va and vb have to refer to the endpoint vertices of an input constraint."; 

const char* doc_context ="\
ctp.context ( Vertex va, Vertex vb) -> Context\n\
Returns the Context relative to one of the constraint enclosing the subconstraint (va,vb).\n\
Precondition: va and vb refer to the vertices of a constrained edge of the triangulation."; 

const char* doc_contexts ="\
ctp.contexts ( Vertex va, Vertex vb) -> Context_iterator\n\
Returns an iterator of Contexts corresponding to the constraints enclosing the (va,vb).\n\
Precondition: va and vb refer to the vertices of a constrained edge of the triangulation.";

const char* doc_number_of_enclosing_constraints ="\
ctp.remove_constraint ( Vertex va,Vertex vb) -> int\n\
Removes the constraint joining the vertices pointed by va and vb.\n\
Precondition: va and vb have to refer to the endpoint vertices of an input constraint."; 

const char* doc_number_of_constraints ="\
ctp.number_of_constraints ( ) -> int";
 
const char* doc_number_of_subconstraints ="\
ctp.number_of_subconstraints ( ) -> int";

const char* doc_vertices_in_constraint ="\
";
const char* doc_constraints ="\
";
const char* doc_subconstraints ="\
";
