// Copyright (c) 2005  INRIA Sophia-Antipolis (France).
// All rights reserved.
//
// This file is part of cgal-python; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with cgal-python.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Id: Py_Delaunay_Triangulation_2_doc.h 132 2006-06-29 12:42:38Z nmeskini $
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal-python/trunk/cgal-python/bindings/Triangulations_2/Py_Delaunay_Triangulation_2_doc.h $
//
// Author(s)     : Naceur Meskini
//=========================================================================

//=======================================================
//	doc of Triangulation_2 module
//=======================================================
enum Delaunay_Triangulation_2_docs_kind {
	Delaunay_2_doc,
	insert_doc,
	push_back_doc,
	remove_doc,
	nearest_vertex_doc,
	dual_doc,
	side_of_oriented_circle_doc,
	last
};
const char* Delaunay_2_docs[] = {
	"The class Delaunay_triangulation_2 is designed to represent the Delaunay triangulation of a set of points in a plane.\n"\
	"A Delaunay triangulation of a set of points is a triangulation of the sets of points that fulfills\n"\
	"the following empty circle property (also called Delaunay property): the circumscribing circle of any facet of the\n"\
	"triangulation contains no point of the set in its interior. \n"\
	"For a point set with no case of cocircularity of more than three points, the Delaunay triangulation is unique, \n"\
	"it is the dual of the Voronoi diagram of the points.\n\n"\
	"http://www.cgal.org/Manual/3.2/doc_html/cgal_manual/Triangulation_2_ref/Class_Delaunay_triangulation_2.html\n",
	"insert(self,Point_2 p,  Face f =  Face()) -> Vertex\n\n"\
	"Inserts point p in the triangulation and returns the corresponding vertex.\n"\
	"If point p coincides with an already existing vertex, this vertex is returned and the triangulation remains unchanged.\n"\
	"If point p is on an edge, the two incident faces are split in two.\n"
	"If point p is strictly inside a face of the triangulation, the face is split in three.\n"\
	"If point p is strictly outside the convex hull, p is linked to all visible points on the convex hull to form the new triangulation.\n"\
	"At last, if p is outside the affine hull(in case of degenerate 1-dimensional or 0-dimensional triangulations),\n"\
	"p is linked all the other vertices to form a triangulation whose dimension is increased by one.\n"\
	"The last argument f is an indication to the underlying locate algorithm of where to start.\n\n"\
	"insert(self,Point_2 p,Locate_type lt, Face loc,int li) ->  Vertex.\n\n"\
	"Same as above except that the location of the point p to be inserted is assumed to be given by (lt,loc,i) \n\n"\
	"insert(self,[p_1,...,p_n]) insert a list of Point_2.\n\n",
	"push_back(self, Point_2 p) Equivalent to insert(p).\n\n",
	"remove(self, Vertex v) -> void\n\n"\
	"Removes the vertex from the triangulation. The created hole is retriangulated.\n"\
	"Precondition: Vertex v must be finite.\n\n",
	"nearest_vertex(self,Point_2 p, Face f= Face()) -> Vertex.\n\n "\
	"returns any nearest vertex of p. The implemented function begins with a location step \n"\
	"and f may be used to initialize the location.\n\n",
	"dual(self, Face f) ->Point_2.\n\n "\
	"Returns the center of the circle circumscribed to face f.\n"\
	"Precondition: f is not infinite.\n\n"\
	"dual(self,Edge e) ->returns a segment, a ray or a line supported by the bisector of the endpoints of e.\n"\
	"If faces incident to e are both finite, a segment whose endpoints are the duals of each incident face is returned. \n"\
	"If only one incident face is finite, a ray whose endpoint is the dual of the finite incident face is returned.\n"\
 	"Otherwise both incident faces are infinite and the bisector line is returned.\n\n ",
	"t.side_of_oriented_circle(self, Face, Point_2) -> Oriented_side\n\
	Returns on which side of the circumcircle of face f lies the point p.\n\
	The circle is assumed to be counterclockwisely oriented, so its positive\n\
	side correspond to its bounded side. This predicate is available only if the\n\
	corresponding predicates on points is provided in the geometric traits class."
 } ;

