// Copyright (c) 2005  INRIA Sophia-Antipolis (France).
// All rights reserved.
//
// This file is part of cgal-python; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with cgal-python.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Id: Triangulations_3_module.cpp 198 2009-03-17 13:27:53Z spion $
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal-python/trunk/cgal-python/bindings/Triangulations_3/Triangulations_3_module.cpp $
//
// Author(s)     : Naceur Meskini
//=========================================================================

#include <CGAL/basic.h>
#if CGAL_VERSION_NR >= CGAL_VERSION_NUMBER(3,4,0)
#  include <CGAL/assertions_behaviour.h>
#endif
#include <include/cgal_exception.h>

#include <boost/python.hpp>
#include <boost/cstdint.hpp>

extern void export_Triangulation_3();
extern void export_Tools_3();
extern void export_Delaunay_triangulation_3();

using namespace boost::python;

BOOST_PYTHON_MODULE(Triangulations_3)
{
	CGAL::set_error_handler(python_cgal_error_handler);
	export_Tools_3();
	export_Triangulation_3();
	export_Delaunay_triangulation_3();
}
